/* Copyright 2016, Michele Santullo
 * This file is part of "keepupnpup".
 *
 * "keepupnpup" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * "keepupnpup" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with "keepupnpup".  If not, see <http://www.gnu.org/licenses/>.
 */

#include "find_redirections.hpp"
#include <ciso646>

namespace kuu {
    auto redirections_for_localaddr (
        const RedirectionsList& parRedirs,
        const std::string& parAddr,
        uint16_t parPort,
        Protocol parProto
    ) {
        return parRedirs | boost::adaptors::filtered([=](const Redirection& parRedir) {
            return parRedir.internal_port == parPort and
                parRedir.protocol == parProto and
                parRedir.internal_client == parAddr
            ;
        });
    }

    auto redirections_not_for_localaddr (
        const RedirectionsList& parRedirs,
        const std::string& parAddr,
        uint16_t parPort,
        Protocol parProto
    ) {
        return parRedirs | boost::adaptors::filtered([=](const Redirection& parRedir) {
            return parRedir.internal_port == parPort and
                parRedir.protocol == parProto and
                parRedir.internal_client != parAddr
            ;
        });
    }
} //namespace kuu
