/* Copyright 2016, Michele Santullo
 * This file is part of "keepupnpup".
 *
 * "keepupnpup" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * "keepupnpup" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with "keepupnpup".  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "redirection.hpp"
#include <vector>
#include <boost/range/adaptor/filtered.hpp>
#include <cstdint>

namespace kuu {
    using RedirectionsList = std::vector<Redirection>;

    auto redirections_for_localaddr (
        const RedirectionsList& parRedirs,
        const std::string& parAddr,
        uint16_t parPort,
        Protocol parProto
    );

    auto redirections_not_for_localaddr (
        const RedirectionsList& parRedirs,
        const std::string& parAddr,
        uint16_t parPort,
        Protocol parProto
    );
} //namespace kuu
